import { Component, ViewChild, OnInit } from '@angular/core';
import * as wjCore from 'wijmo/wijmo';
import { WjGridModule, WjFlexGrid } from 'wijmo/wijmo.angular2.grid';
import * as wjcGridFilter from 'wijmo/wijmo.grid.filter';
import * as wjcGrid from 'wijmo/wijmo.grid';
import * as wjcInput from 'wijmo/wijmo.input';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})
export class AppComponent implements OnInit {
  public static BLANK_VAL = '-----';
  title = 'app';
  @ViewChild('grid') tabGrid: WjFlexGrid;
  data: wjCore.CollectionView;
  detailArr: any[] = [{id:12345, name: 'Adam', dept: 1, deptName: 'Infrastructure services'},
  {id:1345, name: 'James', dept: 2, deptName: 'IT services'},
  {id:34567, name: 'Jacob', dept: 3, deptName: 'Consulting services'},
  {id:24567, name: 'Camey', dept: 1, deptName: 'Infrastructure services'},
  {id:84567, name: 'Andrew', dept: 1, deptName: 'Infrastructure services'},
  {id:34567, name: 'Jim', dept: 1, deptName: 'Infrastructure services'},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL},
  {id:34568, name: 'Jim OO', dept: null, deptName: AppComponent.BLANK_VAL}]

  deptData: any[] = [ {id: null, name : AppComponent.BLANK_VAL},
    {id: 1, name :'Infrastructure services'},
  {id: 2, name: 'IT services'},
  {id: 3, name: 'Consulting services'},
  {id: 4, name: 'Business Advisories'},
  {id: 5, name: 'Strategy Planning'}];

  ngOnInit() {
    console.log('Init');
    this.data = new wjCore.CollectionView(this.detailArr);
    this.data.trackChanges = true;
  }

  onTeamMemberRoleChange(sender:wjcInput.AutoComplete, cellItem: any, selectedVal: any, propObj: any): void {
    const property = propObj.property;
    console.log(selectedVal);
    if(selectedVal == null) {
      selectedVal = { id: null, name : AppComponent.BLANK_VAL };
      // if  selected Value is null, reset Control value to null
      sender.text="";
      sender.selectedIndex=0;
    }
     if(cellItem[property] == selectedVal.id )  {
      console.log('edit start');
      this.data.beginUpdate();
      this.data.editItem(cellItem);
      //cellItem[property] = selectedVal.id;
      console.log(selectedVal.name);
      cellItem[propObj.displayNameProperty] =  selectedVal.name;
      this.data.commitEdit();
      this.data.endUpdate();
    }
  }

  getCount(): void{
    alert(this.data.itemsEdited.length);
  }


}
